#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_DropCFG.h"
std::auto_ptr<M_DropCFG> M_DropCFG::msSingleton(nullptr);

int M_DropCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_DropCFGData* M_DropCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_DropCFGData>& M_DropCFG::GetMapData()
{
	return mMapData;
}

void M_DropCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_DropCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_DropCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		{
			const char* dropInfo = element->Attribute("dropInfo");
			std::vector<std::string> vecdropInfo;
			boost::split(vecdropInfo, dropInfo, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecdropInfo.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecdropInfo[i].c_str(), &temp))
				{
					data.mdropInfo.push_back(temp);
				}
			}
		}
		data.mstarRate = element->IntAttribute("starRate");
		data.mEndRate = element->IntAttribute("EndRate");
		{
			const char* DropCount = element->Attribute("DropCount");
			std::vector<std::string> vecDropCount;
			boost::split(vecDropCount, DropCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDropCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDropCount[i].c_str(), &temp))
				{
					data.mDropCount.push_back(temp);
				}
			}
		}
		data.mOtherTypes = element->IntAttribute("OtherTypes");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_DropCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DropCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_DropCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_DropCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_DropCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readVectorInt(L, "dropInfo", data.mdropInfo);
		LuaCfgHelper::readInt(L, "starRate", data.mstarRate);
		LuaCfgHelper::readInt(L, "EndRate", data.mEndRate);
		LuaCfgHelper::readVectorInt(L, "DropCount", data.mDropCount);
		LuaCfgHelper::readInt(L, "OtherTypes", data.mOtherTypes);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_DropCFG Loaded. Load Data:%u", mMapData.size());
}

void M_DropCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_DropCFG* M_DropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_DropCFG());
	}
	return msSingleton.get();
}

void M_DropCFG::Release()
{
	msSingleton.reset(nullptr);
}
